<template>
  <div class="contenedor">
    <div :id="name" class="charts" ref="GraficaCircular" ></div>
  </div>
</template>

<style scoped>
</style>

<script>
import htmlToImage from "html-to-image";
import * as am4core from "@amcharts/amcharts4/core";
import * as am4charts from "@amcharts/amcharts4/charts";
import am4themes_animated from "@amcharts/amcharts4/themes/animated";
import am4themes_material from "@amcharts/amcharts4/themes/material";

export default {
  name: "GraficaCircular",
  props: {
    data: Object,
    name:String
  },
  data() {
    return {
      value: 0,
      valueTotal: 0,
      color: "",
      isShowId: true
    };
  },
  methods: {
    initChartG() {
      const self = this;
      am4core.useTheme(am4themes_animated);
      // Create chart instance
     
      var chart = am4core.create(this.name, am4charts.RadarChart);
      chart.logo.hidden = true;
      // Add data
      chart.data = [
        {
          category: "",
          value: this.value,
          full: this.valueTotal
        },
      ];

      // Make chart not full circle
      chart.startAngle = 0;
      chart.endAngle = 360;
      
      chart.innerRadius = am4core.percent(80);

      // Create axes
      var categoryAxis = chart.yAxes.push(new am4charts.CategoryAxis());
      categoryAxis.dataFields.category = "category";
      categoryAxis.renderer.grid.template.location = 0;
      categoryAxis.renderer.grid.template.strokeOpacity = 0;
      categoryAxis.renderer.labels.template.horizontalCenter = "right";
      categoryAxis.renderer.labels.template.fontWeight = 50;
      categoryAxis.renderer.labels.template.adapter.add("fill", function (
        fill,
        target
      ) {
        return target.dataItem.index >= 0
          ? chart.colors.getIndex(target.dataItem.index)
          : fill;
      });
      categoryAxis.renderer.minGridDistance = 0;


      var label = chart.createChild(am4core.Label);
      label.text = this.value;
      label.fontSize = 25;
      label.align = "center";
      label.isMeasured = false;
      label.x = am4core.percent(50);
      label.y = am4core.percent(30);
      label.horizontalCenter = "middle";
      label.fontWeight = "bolder";

      var label1 = chart.createChild(am4core.Label);
      label1.text = "Puntos de Venta \n Certificados";
      label1.fontSize = 7;
      label1.align = "center";
      label1.isMeasured = false;
      label1.x = am4core.percent(50);
      label1.y = am4core.percent(55);
      label1.horizontalCenter = "middle";
      label1.fontWeight = "bolder";


      var valueAxis = chart.xAxes.push(new am4charts.ValueAxis());
      valueAxis.renderer.grid.template.strokeOpacity = 0;
      valueAxis.min = 0;
      valueAxis.max = this.valueTotal;
      valueAxis.strictMinMax = true;
      valueAxis.hidden = true;

      // Create series
      var series1 = chart.series.push(new am4charts.RadarColumnSeries());
      series1.dataFields.valueX = "full";
      series1.dataFields.categoryY = "category";
      series1.clustered = false;
      series1.columns.template.fill = new am4core.InterfaceColorSet().getFor(
        "alternativeBackground"
      );
      series1.columns.template.fillOpacity = 0.08;
      series1.columns.template.cornerRadiusTopLeft = 20;
      series1.columns.template.strokeWidth = 0;
      series1.columns.template.radarColumn.cornerRadius = 20;

      var series2 = chart.series.push(new am4charts.RadarColumnSeries());
      series2.dataFields.valueX = "value";
      series2.dataFields.categoryY = "category";
      series2.clustered = false;
      series2.columns.template.strokeWidth = 0;
      series2.columns.template.radarColumn.cornerRadius = 20;

      series2.columns.template.adapter.add("fill", function (fill, target) {
        return am4core.color(self.color);
      });
    },
    
    setValores(data) {
      this.value = data.total_certificados;
      this.valueTotal = data.total_asignados;
      this.color = data.rango_color;
      this.initChartG();
    },
  },
  mounted() {
    this.setValores(this.data);
  },
  created() {
    
  },
};
</script>
<style scoped>
#coberturaOdometro {
  width: 100%;
  height: 400px; /* heightGrafica */
  margin: auto;
}
</style>